/******************************************************************************
 *                      Sources BCB - www.developpez.com                      *
 * -------------------------------------------------------------------------- *
 *                                                                            *
 * LZWCDControl.cpp                                                           *
 * Version: 1.0.0 mise  jour le 13 fvrier 2005                              *
 * Copyright Cryptonyx (http://five.chez.tiscali.fr)                          *
 *                                                                            * 
 * Test avec:                                                                *
 * SE: WinXP                                                                  *
 * IDE: BCB5                                                                  * 
 *                                                                            *
 * -------------------------------------------------------------------------- *
 *                                                                            * 
 * Cet utilitaire illustre une compression/dcompression avec l'algorithme    *
 * de Liv, Zempel et Welch (LZW)                                              *
 *                                                                            *
 * -------------------------------------------------------------------------- * 
 *                                                                            *
 * Retrouvez d'autres ressources BCB sur :                                    *
 *  - http://c.developpez.com/sources/bcb/                                    *
 *  - http://c.developpez.com/faq/bcb/                                        * 
 * Ainsi que sur les forums (http://www.developpez.net/forums/)               *
 *                                                                            *
 ******************************************************************************/

#include <vcl.h>
#include "LZWCDFunctions.h"
#include "LZWCDControl.h"
#pragma hdrstop
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TLZWCDForm *LZWCDForm;
//---------------------------------------------------------------------------
__fastcall TLZWCDForm::TLZWCDForm(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TLZWCDForm::FormCreate(TObject *Sender)
{
	CompressButton->Caption = GUIMessages[LZW_GUI_COMPRESSION];
	DecompressButton->Caption = GUIMessages[LZW_GUI_DECOMPRESSION];
}

//---------------------------------------------------------------------------
void __fastcall TLZWCDForm::CompressButtonClick(TObject *Sender)
{
TLZWClass *MyCompressor;

    // compresse un fichier selectionn
    LZWCDOpenDialog->Title = ListOfControlMessages[LZW_SELECT_COMPRESSION];
    LZWCDOpenDialog->DefaultExt = "";
    LZWCDOpenDialog->FileName = "*.*";
    if(LZWCDOpenDialog->Execute() == false)
        return;

    MyCompressor = new TLZWClass();
    DisplayLine->Text = LZWCDOpenDialog->FileName;
    LZWCDRichEdit->Lines->Clear();
    LZWCDRichEdit->Lines->Add(ListOfControlMessages[LZW_BEGIN_COMPRESSION] + TimeToStr(Time()));
    Repaint();
    MyCompressor->FileCompress(DisplayLine->Text, DisplayLine->Text + ListOfControlMessages[LZW_C_EXTENSION]);

    LZWCDRichEdit->Lines->Add(ListOfControlMessages[LZW_END_COMPRESSION] + TimeToStr(Time()));
    LZWCDRichEdit->Lines->Add(MyCompressor->GetLastError());
    delete MyCompressor;
}
//---------------------------------------------------------------------------
void __fastcall TLZWCDForm::DecompressButtonClick(TObject *Sender)
{
TLZWClass *MyDecompressor;
int i;

    // decompresse un fichier selectionn
    LZWCDOpenDialog->Title = ListOfControlMessages[LZW_SELECT_DECOMPRESSION];
    LZWCDOpenDialog->DefaultExt = ListOfControlMessages[LZW_C_EXTENSION];
    LZWCDOpenDialog->FileName = ListOfControlMessages[LZW_D_EXTENSION];
    if(LZWCDOpenDialog->Execute() == false)
        return;

    DisplayLine->Text = LZWCDOpenDialog->FileName;
    // le fichier doit avoir une extension correcte
    i = DisplayLine->Text.LastDelimiter(".");
    if(DisplayLine->Text.SubString(i, DisplayLine->Text.Length() - i + 1) != ListOfControlMessages[LZW_C_EXTENSION]) {
        MessageDlg(ListOfControlMessages[LZW_INCORRECT_EXTENSION], mtError, TMsgDlgButtons() << mbOK, 0);
        return;
    }
    if(i < 5) {
        MessageDlg(ListOfControlMessages[LZW_INCORRECT_NAME], mtError, TMsgDlgButtons() << mbOK, 0);
        return;
    }
    MyDecompressor = new TLZWClass();
    LZWCDRichEdit->Lines->Clear();
    LZWCDRichEdit->Lines->Add(ListOfControlMessages[LZW_BEGIN_DECOMPRESSION] + TimeToStr(Time()));
    Repaint();
    MyDecompressor->FileDecompress(DisplayLine->Text, DisplayLine->Text.SubString(1, i - 1));

    LZWCDRichEdit->Lines->Add(ListOfControlMessages[LZW_END_DECOMPRESSION] + TimeToStr(Time()));
    LZWCDRichEdit->Lines->Add(MyDecompressor->GetLastError());
    delete MyDecompressor;
}
//---------------------------------------------------------------------------

