/******************************************************************************
 *                      Sources BCB - www.developpez.com                      *
 * -------------------------------------------------------------------------- *
 *                                                                            *
 * LZWCDControl.h                                                             *
 * Version: 1.0.1 mise  jour le 15 fvrier 2005                              *
 * Copyright Cryptonyx (http://five.chez.tiscali.fr)                          *
 *                                                                            * 
 * Test avec:                                                                *
 * SE: WinXP                                                                  *
 * IDE: BCB5                                                                  * 
 *                                                                            *
 * -------------------------------------------------------------------------- *
 *                                                                            * 
 * Cet utilitaire illustre une compression/dcompression avec l'algorithme    *
 * de Liv, Zempel et Welch (LZW)                                              *
 *                                                                            *
 * -------------------------------------------------------------------------- * 
 *                                                                            *
 * Retrouvez d'autres ressources BCB sur :                                    *
 *  - http://c.developpez.com/sources/bcb/                                    *
 *  - http://c.developpez.com/faq/bcb/                                        * 
 * Ainsi que sur les forums (http://www.developpez.net/forums/)               *
 *                                                                            *
 ******************************************************************************/

#ifndef LZWCDControlH
#define LZWCDControlH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
#define LZW_SELECT_COMPRESSION      0
#define LZW_BEGIN_COMPRESSION       1
#define LZW_C_EXTENSION             2
#define LZW_END_COMPRESSION         3
#define LZW_SELECT_DECOMPRESSION    4
#define LZW_D_EXTENSION             5
#define LZW_INCORRECT_EXTENSION     6
#define LZW_INCORRECT_NAME          7
#define LZW_BEGIN_DECOMPRESSION     8
#define LZW_END_DECOMPRESSION       9
#define LZW_GUI_COMPRESSION         0
#define LZW_GUI_DECOMPRESSION       1
//--------------------------------------------------------------------------
// Choisir une langue avant compilation du code
//--------------------------------------------------------------------------
#define FRENCH
//#define ENGLISH
#ifdef FRENCH
AnsiString ListOfControlMessages[] = {
    "Choisissez le fichier  compresser",       // 0
    "Compression commence  ",                 // 1
    ".lzw",                                     // 2
    "Compression termine  ",                  // 3
    "Choisissez le fichier  dcompresser",     // 4
    "*.lzw",                                    // 5
    "Le fichier a une extension incorrecte",    // 6
    "Le fichier a un nom incorrect",            // 7
    "Dcompression commence  ",               // 8
    "Dcompression termine  ",                // 9
};
AnsiString GUIMessages[] = {
    "Compresser",               // 0
    "Dcompresser",             // 1
};
#endif
#ifdef ENGLISH
AnsiString ListOfControlMessages[] = {
    "Select a file to compress",                // 0
    "Compression started at ",                  // 1
    ".lzw",                                     // 2
    "Compression ended at ",                    // 3
    "Select a file to decompress",              // 4
    "*.lzw",                                    // 5
    "Incorrect file extension",                 // 6
    "Incorrect file name",                      // 7
    "Decompression started at ",                // 8
    "Decompression ended at ",                  // 9
};
AnsiString GUIMessages[] = {
    "Compress",         // 0
    "Decompress",       // 1
};
#endif

//---------------------------------------------------------------------------
class TLZWCDForm : public TForm
{
__published:	// Composants grs par l'EDI
    TRichEdit   *LZWCDRichEdit;
    TButton     *CompressButton;
    TButton     *DecompressButton;
    TEdit       *DisplayLine;
    TOpenDialog *LZWCDOpenDialog;
    void __fastcall CompressButtonClick(TObject *Sender);
    void __fastcall DecompressButtonClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
private:	// Dclarations utilisateur
public:		// Dclarations utilisateur
    __fastcall TLZWCDForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TLZWCDForm *LZWCDForm;
//---------------------------------------------------------------------------
#endif
